#
# Copyright (c) 2011 Mellanox Technologies. All rights reserved.
#
# This Software is licensed under one of the following licenses:
#
# 1) under the terms of the "Common Public License 1.0" a copy of which is
#    available from the Open Source Initiative, see
#    http://www.opensource.org/licenses/cpl.php.
#
# 2) under the terms of the "The BSD License" a copy of which is
#    available from the Open Source Initiative, see
#    http://www.opensource.org/licenses/bsd-license.php.
#
# 3) under the terms of the "GNU General Public License (GPL) Version 2" a
#    copy of which is available from the Open Source Initiative, see
#    http://www.opensource.org/licenses/gpl-license.php.
#
# Licensee has the right to choose one of the above licenses.
#
# Redistributions of source code must retain the above copyright
# notice and one of the license notices.
#
# Redistributions in binary form must reproduce both the above copyright
# notice, one of the license notices in the documentation
# and/or other materials provided with the distribution.
#
#

%define debug_package ${nil}

%define OFED_RELEASE	1.5.4.1
%define OFED_DIR ofa_kernel-%{OFED_RELEASE}
%define SOURCE_DIR %{_builddir}/ofed-driver/

# these must be pre-processed before hand:
%{!?PKG_VERSION: %global PKG_VERSION 3.4}
%{!?PKG_RELEASE: %global PKG_RELEASE 1}

%{!?KVERSION:	 %global KVERSION    %(uname -r)}
%{!?LIB_MOD_DIR: %global LIB_MOD_DIR /lib/modules/%{KVERSION}/updates}
%{!?IB_CONF_DIR: %global IB_CONF_DIR /etc/infiniband}

# vars for passing in extra flags to build ofed:
%{!?KERN_SRC:     %global KERN_SRC %{nil}}
%{!?KERN_MOD:     %global KERN_MOD %{nil}}
%{!?EXTRA_MFLAGS: %global EXTRA_MFLAGS OPENIB_KERNEL_EXTRA_CFLAGS:=-I/usr/src/kernels/%{KVERSION}/include/modules/}
%{!?EXTRA_CONF:   %global EXTRA_CONF /lib/modules/%{KVERSION}/scif.symvers}

# compiling against mofed, default no
%{!?MOFED:	  %global MOFED 0}

%define default_options "\
	--with-user_access-mod		\
	--with-addr_trans-mod		\
	--with-user_mad-mod		\
	--with-core-mod			\
	--with-mthca-mod		\
	--with-mlx4-mod			\
	--with-mlx4_en-mod		\
	--with-cxgb3-mod		\
	--with-cxgb4-mod		\
	--with-nes-mod			\
	--with-ipoib-mod		\
	--with-sdp-mod			\
	--with-srp-mod			\
	--with-srp-target-mod		\
	--with-rds-mod			\
	--with-madeye-mod		\
	--with-qib-mod			\
"

# Do OS detection and blacklisting here:
%if %{MOFED}
%define configure_options "--with-user_access-mod"
%else
%define configure_options %{default_options}
%endif

# Kernel module packages to be included
%define build_mthca	%(! echo %{configure_options} | grep -q "with-mthca-mod" ; echo -n $?)
%define build_qib	%(! echo %{configure_options} | grep -q "with-qib-mod" ; echo -n $?)
%define build_ipath	%(! echo %{configure_options} | grep -q "with-ipath_inf-mod" ; echo -n $?)
%define build_ehca	%(! echo %{configure_options} | grep -q "with-ehca-mod" ; echo -n $?)
%define build_ipoib	%(! echo %{configure_options} | grep -q "with-ipoib-mod" ; echo -n $?)
%define build_sdp	%(! echo %{configure_options} | grep -q "with-sdp-mod" ; echo -n $?)
%define build_srp	%(! echo %{configure_options} | grep -q "with-srp-mod" ; echo -n $?)
%define build_srpt	%(! echo %{configure_options} | grep -q "with-srp-target-mod" ; echo -n $?)
%define build_iser	%(! echo %{configure_options} | grep -q "with-iser-mod" ; echo -n $?)
%define build_oiscsi	%(! echo %{configure_options} | grep -q "with-iscsi-mod" ; echo -n $?)
%define build_rds	%(! echo %{configure_options} | grep -q "with-rds-mod" ; echo -n $?)
%define build_cxgb3	%(! echo %{configure_options} | grep -q "with-cxgb3-mod" ; echo -n $?)
%define build_cxgb4	%(! echo %{configure_options} | grep -q "with-cxgb4-mod" ; echo -n $?)
%define build_nes	%(! echo %{configure_options} | grep -q "with-nes-mod" ; echo -n $?)
%define build_mlx4	%(! echo %{configure_options} | grep -q "with-mlx4-mod" ; echo -n $?)
%define build_mlx4_en	%(! echo %{configure_options} | grep -q "with-mlx4_en-mod" ; echo -n $?)
%define build_qlgc_vnic	%(! echo %{configure_options} | grep -q "with-qlgc_vnic-mod" ; echo -n $?)
%define build_nfsrdma	%(! echo %{configure_options} | grep -q "with-nfsrdma-mod" ; echo -n $?)

# always include udev rules
%define include_udev_rules 1

Name:		ofed-driver
Summary:	Host-side IB Drivers for Intel® Xeon Phi(TM) Coprocessor
Version:	%{PKG_VERSION}
Vendor:		Intel Corporation
Url:		http://www.intel.com
Release:	%{PKG_RELEASE}
License:	GPLv2 or BSD
Source:		ofed-driver.tgz
Group:		System Environment/Base
BuildRoot:	%{_topdir}/BUILDROOT
BuildRequires:	mpss-modules-dev-%{KVERSION}

%description
Core, Hardware, and ULPs for InfiniBand and Intel® Xeon Phi(TM) Coprocessor

%package -n	ofed-driver-%{KVERSION}
Summary:	Host-side IB Drivers for Intel® Xeon Phi(TM) Coprocessor
Group:		System Environment/Base

Requires:	ofed-ibpd
Provides:	ofed-driver
Obsoletes:	kernel-ib-devel = %{OFED_RELEASE}
Conflicts:	kernel-ib-devel = %{OFED_RELEASE}

%description -n	ofed-driver-%{KVERSION}
Core, Hardware, and ULPs for InfiniBand and Intel® Xeon Phi(TM) Coprocessor, kernel version: %{KVERSION}

%package -n	ofed-driver-devel-%{KVERSION}
Summary:	IB driver include files and Module.symvers for Intel® MIC Host
Group:		System Environment/Base

Provides:	ofed-driver-devel
Obsoletes:	kernel-ib-devel = %{OFED_RELEASE}
Conflicts:	kernel-ib-devel = %{OFED_RELEASE}
Requires:	ofed-driver-%{KVERSION} = %{version}

%description -n	ofed-driver-devel-%{KVERSION}
InfiniBand driver include files and Module.symvers for development

###
### prep
###
%prep
%setup -q -n ofed-driver

echo Building for kernel: %{KVERSION}

# Obtain a pristine copy of the OFED source
tar -xzf %{SOURCE_DIR}/src/pristine/%{OFED_DIR}.tgz
cd %{OFED_DIR}

%define PATCH_DIR %{SOURCE_DIR}/src/patches

# Export config parameters for the MIC related source
export WITH_MAKE_PARAMS="\
CONFIG_IBP_SERVER=m \
CONFIG_INFINIBAND_SCIF=m \
KBUILD_EXTRA_SYMBOLS=%{EXTRA_CONF} \
"

# Create the config file and apply OFED patches
./configure				\
	--kernel-version=%{KVERSION}	\
	%{KERN_SRC}			\
	%{KERN_MOD}			\
	%{configure_options}

# Add the MIC related source to the OFED build tree
cp -a %{SOURCE_DIR}/src/kernel/* .

# Applying patches clobbers config.mk; save before applying MIC related patches
mv config.mk config.mk.save
%define BACKPORT_DIR $(./ofed_scripts/get_backport_dir.sh %{KVERSION})

# Apply the backport patches for MIC
./ofed_scripts/ofed_patch.sh --with-patchdir=%{PATCH_DIR}/%{BACKPORT_DIR}

# Restore the config file
mv config.mk.save config.mk

# needed for compiling only scif/ibp modules
%if %{MOFED}
cp /usr/src/ofa_kernel/default/Module.symvers .
echo "obj-\$(CONFIG_INFINIBAND_SCIF)   += drivers/infiniband/hw/scif/" >> Makefile
echo "obj-\$(CONFIG_IBP_SERVER)        += drivers/infiniband/ibp/" >> Makefile
%endif

###
### build
###
%build
cd %{OFED_DIR}

%if %{MOFED}
  %define MLNX_RPM %(rpm -q --whatprovides /usr/src/ofa_kernel | head -n 1)
  %define MLNX_VER %(rpm -q --queryformat "[%{VERSION}]" %{MLNX_RPM})
  # check for version 2.1
  %define MOFED_2_1 %(! echo %{MLNX_VER} | grep -q "2.1" ; echo -n $?)

  # check for sles host
  %if "%{_vendor}" == "suse"
    %define SUSE_FIX \ -include /usr/src/ofa_kernel/default/include/linux/compat-2.6.h
  %else
    %define SUSE_FIX %{nil}
  %endif

  %if %{MOFED_2_1}
    %define MOFED_FLAGS "-DMOFED -DMOFED_2_1 -DCONFIG_MK1OM -I/usr/src/ofa_kernel/default/include"
  %else
    %define MOFED_FLAGS "-DMOFED -DCONFIG_MK1OM -I/usr/src/ofa_kernel/default/include %{SUSE_FIX}"
  %endif

  %{__make} %{?_smp_mflags} %{EXTRA_MFLAGS} kernel KERNEL_NFS_FS_CFLAGS:=%{MOFED_FLAGS}
%else
  %{__make} %{?_smp_mflags} %{EXTRA_MFLAGS} kernel
%endif

###
### install
###
%install
rm -rf %{buildroot}
cd %{OFED_DIR}
%{__make} install_kernel INSTALL_MOD_PATH=%{buildroot} INSTALL_MOD_DIR=updates


%if ! %{MOFED}
# install stock configuration and init service
install -D -m 0644 %{SOURCE_DIR}/%{OFED_DIR}/ofed_scripts/openib.conf %{buildroot}/%{IB_CONF_DIR}/openib.conf
install -D -m 0755 %{SOURCE_DIR}/%{OFED_DIR}/ofed_scripts/openibd %{buildroot}/etc/init.d/openibd
install -D -m 0755 %{SOURCE_DIR}/%{OFED_DIR}/ofed_scripts/sysctl_perf_tuning %{buildroot}/sbin/sysctl_perf_tuning
%endif

# install openib service script
install -D -m 0755 %{SOURCE_DIR}/src/scripts/ofed-mic %{buildroot}/etc/init.d/ofed-mic
install -D -m 0644 %{SOURCE_DIR}/src/scripts/ibscif.conf %{buildroot}/etc/modprobe.d/ibscif.conf
install -D -m 0755 %{SOURCE_DIR}/src/scripts/ibscif-opt %{buildroot}/usr/sbin/ibscif-opt

%if %{build_mlx4}
install -d $RPM_BUILD_ROOT/%{_bindir}
install -m 0755 %{SOURCE_DIR}/%{OFED_DIR}/ofed_scripts/ibdev2netdev $RPM_BUILD_ROOT/%{_bindir}
%endif

%if %{build_mlx4_en}
install -d $RPM_BUILD_ROOT/sbin
install -m 0755 %{SOURCE_DIR}/%{OFED_DIR}/ofed_scripts/connectx_port_config $RPM_BUILD_ROOT/sbin
install -d $RPM_BUILD_ROOT/etc/modprobe.d
install -m 0644 %{SOURCE_DIR}/%{OFED_DIR}/ofed_scripts/mlx4_en.conf $RPM_BUILD_ROOT/etc/modprobe.d
touch $RPM_BUILD_ROOT/%{IB_CONF_DIR}/connectx.conf
%endif

%if %{build_qib}
install -m 0644 %{SOURCE_DIR}/%{OFED_DIR}/ofed_scripts/truescale.cmds $RPM_BUILD_ROOT/%{IB_CONF_DIR}
%endif

%if %{build_ipoib}
install -d $RPM_BUILD_ROOT/etc/modprobe.d
install -m 0644 %{SOURCE_DIR}/%{OFED_DIR}/ofed_scripts/ib_ipoib.conf $RPM_BUILD_ROOT/etc/modprobe.d
%endif

%if %{build_ipoib} || %{MOFED}
install -d $RPM_BUILD_ROOT/etc/mpss
install -m 0644 %{SOURCE_DIR}/src/scripts/ipoib.conf $RPM_BUILD_ROOT/etc/mpss
install -d $RPM_BUILD_ROOT/usr/share/doc/%{name}-%{version}
install -m 0644 %{SOURCE_DIR}/src/docs/lustre-phi.txt $RPM_BUILD_ROOT/usr/share/doc/%{name}-%{version}
install -m 0644 %{SOURCE_DIR}/src/docs/srp-phi.txt $RPM_BUILD_ROOT/usr/share/doc/%{name}-%{version}
%endif

%if %{build_sdp}
install -d $RPM_BUILD_ROOT/etc/modprobe.d
install -m 0644 %{SOURCE_DIR}/%{OFED_DIR}/ofed_scripts/ib_sdp.conf $RPM_BUILD_ROOT/etc/modprobe.d
%endif

%if %{include_udev_rules}
install -d $RPM_BUILD_ROOT/etc/udev/rules.d
install -m 0644 %{SOURCE_DIR}/%{OFED_DIR}/ofed_scripts/90-ib.rules $RPM_BUILD_ROOT/etc/udev/rules.d
%endif

# devel pacakge
mkdir -p $RPM_BUILD_ROOT/usr/src/%{name}
cp -a %{SOURCE_DIR}/%{OFED_DIR}/include $RPM_BUILD_ROOT/usr/src/%{name}
cp %{SOURCE_DIR}/%{OFED_DIR}/Module.symvers $RPM_BUILD_ROOT/usr/src/%{name}

%clean
rm -rf %{buildroot}

%post -n ofed-driver-%{KVERSION}
if [ $1 -ge 1 ]; then # 1 : This package is being installed or reinstalled

%if %{MOFED}
    chkconfig --add ofed-mic &> /dev/null
    chkconfig ofed-mic off
    /sbin/depmod %{KVERSION}
%else

count_ib_ports()
{
    local cnt=0
    local tmp_cnt=0

    tmp_cnt=$(/sbin/lspci -n | grep "15b3:6282" | wc -l | tr -d '[:space:]') # Arbel mode
    cnt=$[ $cnt + 2*${tmp_cnt} ]

    tmp_cnt=$(/sbin/lspci -n | grep -E "15b3:5e8c|15b3:6274" | wc -l | tr -d '[:space:]') # Sinai
    cnt=$[ $cnt + ${tmp_cnt} ]

    tmp_cnt=$(/sbin/lspci -n | grep -E "15b3:5a44|15b3:6278" | wc -l | tr -d '[:space:]') # Tavor mode
    cnt=$[ $cnt + 2*${tmp_cnt} ]

    tmp_cnt=$(/sbin/lspci -n | grep -E "1fc1:|1077:7220" | wc -l | tr -d '[:space:]') # QLogic SDR and DDR HCA
    cnt=$[ $cnt + ${tmp_cnt} ]

    tmp_cnt=$(/sbin/lspci -n | grep -E "1077:7322" | wc -l | tr -d '[:space:]') # QLogic QDR HCA
    cnt=$[ $cnt + 2*${tmp_cnt} ]
    return $cnt
}

count_ib_ports
ports_num=$?

# Set default number of ports to 2 if no HCAs found
if [ $ports_num -eq 0 ]; then
    ports_num=2
fi

##################################################################################################
#                                  Modules configuration                                         #
##################################################################################################

%if %{build_ipoib}
for (( i=0 ; i < $ports_num ; i++ ))
do
cat >> /etc/modprobe.d/ib_ipoib.conf << EOF
alias ib${i} ib_ipoib
EOF
done
%endif

/sbin/depmod %{KVERSION}

##################################################################################################

if [[ -f /etc/redhat-release || -f /etc/rocks-release ]]; then
perl -i -ne 'if (m@^#!/bin/bash@) {
        print q@#!/bin/bash
#
# chkconfig: 235 05 95
# description: Activates/Deactivates InfiniBand Driver to \
#              start at boot time.
#
### BEGIN INIT INFO
# Provides:       openibd
# Required-Start: $local_fs
# Required-Stop: opensmd
# Default-Start:  2 3 5
# Default-Stop: 0 1 2 6
# Short-Description: Bring up/down openib
# Description:    Activates/Deactivates InfiniBand Driver to \
#                 start at boot time.
### END INIT INFO
@;
                 } else {
                     print;
                 }' /etc/init.d/openibd

    chkconfig --add openibd &> /dev/null
    chkconfig --add ofed-mic &> /dev/null
    chkconfig ofed-mic off
fi

if [ -f /etc/SuSE-release ]; then
    local_fs='$local_fs'
    openiscsi=''
    %if %{build_oiscsi}
        openiscsi='open-iscsi'
    %endif
        perl -i -ne "if (m@^#!/bin/bash@) {
        print q@#!/bin/bash
### BEGIN INIT INFO
# Provides:       openibd
# Required-Start: $local_fs
# Required-Stop: opensmd $openiscsi
# Default-Start:  2 3 5
# Default-Stop: 0 1 2 6
# Description:    Activates/Deactivates InfiniBand Driver to \
#                 start at boot time.
### END INIT INFO
@;
                 } else {
                     print;
                 }" /etc/init.d/openibd

    chkconfig --add openibd &> /dev/null
    chkconfig --add ofed-mic &> /dev/null
fi

if [ -f /etc/debian_version ]; then
    local_fs='$local_fs'
    openiscsi=''
    %if %{build_oiscsi}
        openiscsi='open-iscsi'
    %endif
        perl -i -ne "if (m@^#!/bin/bash@) {
        print q@#!/bin/bash
### BEGIN INIT INFO
# Provides:       openibd
# Required-Start: $local_fs
# Required-Stop: opensmd $openiscsi
# Default-Start:  2 3 5
# Default-Stop: 0 1 2 6
# Description:    Activates/Deactivates InfiniBand Driver to \
#                 start at boot time.
### END INIT INFO
@;
                 } else {
                     print;
                 }" /etc/init.d/openibd

    update-rc.d openibd defaults &> /dev/null
    update-rc.d ofed-mic defaults &> /dev/null
fi

echo >> %{IB_CONF_DIR}/openib.conf
echo "# Load UCM module" >> %{IB_CONF_DIR}/openib.conf
echo "UCM_LOAD=no" >> %{IB_CONF_DIR}/openib.conf
echo >> %{IB_CONF_DIR}/openib.conf
echo "# Load RDMA_CM module" >> %{IB_CONF_DIR}/openib.conf
echo "RDMA_CM_LOAD=yes" >> %{IB_CONF_DIR}/openib.conf
echo >> %{IB_CONF_DIR}/openib.conf
echo "# Load RDMA_UCM module" >> %{IB_CONF_DIR}/openib.conf
echo "RDMA_UCM_LOAD=yes" >> %{IB_CONF_DIR}/openib.conf
echo >> %{IB_CONF_DIR}/openib.conf
echo "# Increase ib_mad thread priority" >> %{IB_CONF_DIR}/openib.conf
echo "RENICE_IB_MAD=no" >> %{IB_CONF_DIR}/openib.conf
echo >> %{IB_CONF_DIR}/openib.conf
echo "# Run sysctl performance tuning script" >> %{IB_CONF_DIR}/openib.conf
echo "RUN_SYSCTL=no" >> %{IB_CONF_DIR}/openib.conf

%if %{build_mthca}
       echo >> %{IB_CONF_DIR}/openib.conf
       echo "# Load MTHCA" >> %{IB_CONF_DIR}/openib.conf
       echo "MTHCA_LOAD=yes" >> %{IB_CONF_DIR}/openib.conf
%endif

%if %{build_qib}
       echo >> %{IB_CONF_DIR}/openib.conf
       echo "# Load QIB" >> %{IB_CONF_DIR}/openib.conf
       echo "QIB_LOAD=yes" >> %{IB_CONF_DIR}/openib.conf
%endif

%if %{build_ipath}
       echo >> %{IB_CONF_DIR}/openib.conf
       echo "# Load IPATH" >> %{IB_CONF_DIR}/openib.conf
       echo "IPATH_LOAD=yes" >> %{IB_CONF_DIR}/openib.conf
%endif

%if %{build_ehca}
       echo >> %{IB_CONF_DIR}/openib.conf
       echo "# Load eHCA" >> %{IB_CONF_DIR}/openib.conf
       echo "EHCA_LOAD=yes" >> %{IB_CONF_DIR}/openib.conf
%endif

%if %{build_mlx4}
       echo >> %{IB_CONF_DIR}/openib.conf
       echo "# Load MLX4 modules" >> %{IB_CONF_DIR}/openib.conf
       echo "MLX4_LOAD=yes" >> %{IB_CONF_DIR}/openib.conf
%endif

%if %{build_mlx4_en}
       echo >> %{IB_CONF_DIR}/openib.conf
       echo "# Load MLX4_EN module" >> %{IB_CONF_DIR}/openib.conf
       echo "MLX4_EN_LOAD=yes" >> %{IB_CONF_DIR}/openib.conf
%endif

%if %{build_cxgb3}
       echo >> %{IB_CONF_DIR}/openib.conf
       echo "# Load CXGB3 modules" >> %{IB_CONF_DIR}/openib.conf
       echo "CXGB3_LOAD=yes" >> %{IB_CONF_DIR}/openib.conf
%endif

%if %{build_cxgb4}
       echo >> %{IB_CONF_DIR}/openib.conf
       echo "# Load CXGB4 modules" >> %{IB_CONF_DIR}/openib.conf
       echo "CXGB4_LOAD=yes" >> %{IB_CONF_DIR}/openib.conf
%endif

%if %{build_nes}
       echo >> %{IB_CONF_DIR}/openib.conf
       echo "# Load NES modules" >> %{IB_CONF_DIR}/openib.conf
       echo "NES_LOAD=yes" >> %{IB_CONF_DIR}/openib.conf
%endif

%if %{build_ipoib}
       echo >> %{IB_CONF_DIR}/openib.conf
       echo "# Load IPoIB" >> %{IB_CONF_DIR}/openib.conf
       echo "IPOIB_LOAD=yes" >> %{IB_CONF_DIR}/openib.conf
       echo >> %{IB_CONF_DIR}/openib.conf
       echo "# Enable IPoIB Connected Mode" >> %{IB_CONF_DIR}/openib.conf
       echo "SET_IPOIB_CM=yes" >> %{IB_CONF_DIR}/openib.conf
%endif

%if %{build_sdp}
       echo >> %{IB_CONF_DIR}/openib.conf
       echo "# Load SDP module" >> %{IB_CONF_DIR}/openib.conf
       echo "SDP_LOAD=yes" >> %{IB_CONF_DIR}/openib.conf
%endif

%if %{build_srp}
       echo >> %{IB_CONF_DIR}/openib.conf
       echo "# Load SRP module" >> %{IB_CONF_DIR}/openib.conf
       echo "SRP_LOAD=no" >> %{IB_CONF_DIR}/openib.conf
%endif

%if %{build_srpt}
       echo >> %{IB_CONF_DIR}/openib.conf
       echo "# Load SRP Target module" >> %{IB_CONF_DIR}/openib.conf
       echo "SRPT_LOAD=no" >> %{IB_CONF_DIR}/openib.conf
%endif

%if %{build_iser}
       echo >> %{IB_CONF_DIR}/openib.conf
       echo "# Load ISER module" >> %{IB_CONF_DIR}/openib.conf
       echo "ISER_LOAD=no" >> %{IB_CONF_DIR}/openib.conf
%endif

%if %{build_rds}
       echo >> %{IB_CONF_DIR}/openib.conf
       echo "# Load RDS module" >> %{IB_CONF_DIR}/openib.conf
       echo "RDS_LOAD=no" >> %{IB_CONF_DIR}/openib.conf
%endif

%if %{build_qlgc_vnic}
       echo >> %{IB_CONF_DIR}/openib.conf
       echo "# Load QLogic VNIC module" >> %{IB_CONF_DIR}/openib.conf
       echo "QLGC_VNIC_LOAD=yes" >> %{IB_CONF_DIR}/openib.conf
%endif

%endif # MOFED

fi # 1 : closed
# END of post install

###
### preun section
###
%preun -n ofed-driver-%{KVERSION}
if [ $1 = 0 ]; then  # 1 : Erase, not upgrade
%if %{MOFED}
        chkconfig --del ofed-mic &> /dev/null
%else
    if [ -f /etc/debian_version ]; then
        update-rc.d ofed-mic remove &> /dev/null
        update-rc.d openibd remove &> /dev/null
    else
        chkconfig --del openibd &> /dev/null
        chkconfig --del ofed-mic &> /dev/null
    fi
%endif # MOFED
fi

###
### post uninstall section
###
%postun -n ofed-driver-%{KVERSION}
if [ $1 = 0 ]; then  # 1 : Erase, not upgrade
        # Clean /etc/modprobe.d/ofed.conf
        # Remove previous configuration if exist
        /sbin/depmod %{KVERSION}

%if ! %{MOFED}
# Clean udev.rules
%if ! %{include_udev_rules}
    if [ -e /etc/udev/udev.rules ]; then
        perl -ni -e 'if (/\# Infiniband devices \#$/) { $filter = 1 }' -e 'if (!$filter) { print }' -e 'if (/\# End Infiniband devices \#$/){ $filter = 0 }' /etc/udev/udev.rules
    fi
%endif

# Clean sysctl.conf
if [ -f /etc/sysctl.conf ]; then
perl -ni -e 'if (/\#\# OFED Network tuning parameters \#\#$/) { $filter = 1 }' -e 'if (!$filter) { print }' -e 'if (/\#\# END of OFED parameters \#\#$/){ $filter = 0 }' /etc/sysctl.conf
fi
%endif # MOFED

fi

###
### Files
###
%files -n ofed-driver-%{KVERSION}
%defattr(-,root,root,-)
%if ! %{MOFED}
%dir %{IB_CONF_DIR}
%config(noreplace) %{IB_CONF_DIR}/openib.conf
%{_sysconfdir}/init.d/openibd
/sbin/sysctl_perf_tuning
%endif

%{_sysconfdir}/init.d/ofed-mic
%config(noreplace) %{_sysconfdir}/modprobe.d/ibscif.conf
/usr/sbin/ibscif-opt
%dir %{LIB_MOD_DIR}
%{LIB_MOD_DIR}/*

%if %{include_udev_rules}
/etc/udev/rules.d/90-ib.rules
%endif

%if %{build_qib}
%config(noreplace) %{IB_CONF_DIR}/truescale.cmds
%endif

%if %{build_ipoib}
/etc/modprobe.d/ib_ipoib.conf
%endif

%if %{build_ipoib} || %{MOFED}
%config(noreplace) %{_sysconfdir}/mpss/ipoib.conf
/usr/share/doc/%{name}-%{version}/lustre-phi.txt
/usr/share/doc/%{name}-%{version}/srp-phi.txt
%endif

%if %{build_sdp}
/etc/modprobe.d/ib_sdp.conf
%endif

%if %{build_mlx4}
%{_bindir}/ibdev2netdev
%endif

%if %{build_mlx4_en}
/sbin/connectx_port_config
/etc/modprobe.d/mlx4_en.conf
%config(noreplace) %{IB_CONF_DIR}/connectx.conf
%endif

%files -n ofed-driver-devel-%{KVERSION}
%defattr(-,root,root,-)
%dir /usr/src/%{name}
/usr/src/%{name}/*

%changelog
* Thu Jan 21 2014 Patrick McCormick <patrick.m.mccormick@intel.com>
- Add mofed special casing to work with ipoib

* Thu Jul 18 2013 Jay E Sternberg <jay.e.sternberg@intel.com>
- add mic configuration for ipoib

* Fri Sep 21 2012 Patrick McCormick <patrick.m.mccormick@intel.com>
- Update summary and description to use official branding

* Thu Apr 27 2012 Jianxin Xiong <jianxin.xiong@intel.com>
- Add /usr/sbin/ibscif-opt

* Thu Apr 26 2012 Jianxin Xiong <jianxin.xiong@intel.com>
- Add /etc/init.d/ofed-mic
- Add /etc/modprobe.d/ibscif.conf
- Remove a huge block of duplicated content

* Mon Mar  5 2012 Jerrie Coffman <jerrie.l.coffman@intel.com>
- Added SCIF Module.symvers to the package
- Add default definition for PKG_VERSION

* Mon Feb 27 2012 Patrick McCormick <patrick.m.mccormick@intel.com>
- Update summary to include trademark registration symbol

* Fri Feb 10 2012 Jerrie Coffman <jerrie.l.coffman@intel.com>
- Update for OFED-1.5.4.1

* Mon Dec  5 2011 Jerrie Coffman <jerrie.l.coffman@intel.com>
- Update for OFED-1.5.4

* Fri Nov 18 2011 Jerrie Coffman <jerrie.l.coffman@intel.com>
- Add config and install rules from the ofa_kernel spec file

* Tue Nov 15 2011 Jianxin Xiong <jianxin.xiong@intel.com>
- Allow the version being set externally

* Mon Nov 14 2011 Jianxin Xiong <jianxin.xiong@intel.com>
- Add "conflicts" and "obsoletes" clause
- Rename the package to intel-mic-ofed-kmod

* Wed Nov  2 2011 Jerrie Coffman <jerrie.l.coffman@intel.com>
- Build all kernel modules
- Add devel package

* Tue Aug 16 2011 Jerrie Coffman <jerrie.l.coffman@intel.com>
- Correct typos
- Simplify directory changes

* Mon Aug 15 2011 Jianxin Xiong <jianxin.xiong@intel.com>
- Add scif_ib driver
- Use a local copy of the prestine OFED source
- Change the descriptions

* Tue Aug 12 2011 Jerrie Coffman <jerrie.l.coffman@intel.com>
- Initial release
